﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using Telerik.Web.UI.Widgets;
using System.IO;

public partial class _Default : System.Web.UI.Page
{
	protected void Page_Load(object sender, EventArgs e)
	{
		RadFileExplorer1.Configuration.ContentProviderTypeName = typeof(CustomProvider).AssemblyQualifiedName;
	}

	public class CustomProvider : FileSystemContentProvider
	{
		public CustomProvider(HttpContext context, string[] searchPatterns, string[] viewPaths, string[] uploadPaths, string[] deletePaths, string selectedUrl, string selectedItemTag)
			: base(context, searchPatterns, viewPaths, uploadPaths, deletePaths, selectedUrl, selectedItemTag)
		{ }


		public override DirectoryItem ResolveRootDirectoryAsTree(string path)
		{
			DirectoryItem originalDir = base.ResolveRootDirectoryAsTree(path);
			string physicalPath = Context.Server.MapPath(path);

			List<DirectoryItem> childDirItems = new List<DirectoryItem>();
			foreach (DirectoryItem currentDir in originalDir.Directories)
			{
				string physicalPathChildFile = Context.Server.MapPath(currentDir.FullPath);
				DirectoryItem childDirItem = new DirectoryItem(currentDir.Name + "(" + Directory.GetFiles(physicalPathChildFile).Length + ")",
																currentDir.Location,
																currentDir.FullPath,
																currentDir.Tag,
																currentDir.Permissions,
																currentDir.Files,
																currentDir.Directories
																  );
				childDirItems.Add(childDirItem);
			}


			DirectoryItem dirItem = new DirectoryItem(originalDir.Name + "(" + Directory.GetFiles(physicalPath).Length + ")",
													  originalDir.Location,
													  originalDir.FullPath,
													  originalDir.Tag,
													  originalDir.Permissions,
													  originalDir.Files,
													 childDirItems.ToArray()
													  );
			return dirItem;
		}

		public override DirectoryItem ResolveDirectory(string path)
		{
			DirectoryItem originalDir = base.ResolveDirectory(path);
			string physicalPath = Context.Server.MapPath(path);

			DirectoryItem dirItem = new DirectoryItem(originalDir.Name + "(" + Directory.GetFiles(physicalPath).Length + ")",
													  originalDir.Location,
													  originalDir.FullPath,
													  originalDir.Tag,
													  originalDir.Permissions,
													  originalDir.Files,
													  originalDir.Directories
													  );
			return dirItem;
		}
	}
}